// NTSTATUSExplorerDlg.cpp : implementation file
//

#include "stdafx.h"
#include <afxtempl.h>
#include "StatusList.h"
#include "NTSTATUSExplorer.h"
#include "NTSTATUSExplorerDlg.h"
#include "regvars.h"
#include "FileOptions.h"

#include "winIoctl.h"
#include "statusRIoctl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

class WinErrorData {
    public:
	WinErrorData(CString & n, DWORD v) { name = n; value = v; }
	virtual ~WinErrorData() { }
    
	CString name;
	DWORD value;
		   };

class WinErrorTable {
     public:
	WinErrorTable() { }
	virtual ~WinErrorTable();
	void Add(CString & n, DWORD v);
	CString Lookup(DWORD v);
     protected:
	CList<WinErrorData *, WinErrorData *> data;
		    };

WinErrorTable::~WinErrorTable()
    {
     if(data.IsEmpty())
	return;

     while(!data.IsEmpty())
        { /* delete each */
	 WinErrorData * d = data.RemoveHead();
	 delete d;
	} /* delete each */
    }

void WinErrorTable::Add(CString & n, DWORD v)
   {
    WinErrorData * d = new WinErrorData(n, v);
    data.AddHead(d);
   }

CString WinErrorTable::Lookup(DWORD v)
   {
    if(data.IsEmpty())
       return CString(_T(""));
    POSITION p = data.GetHeadPosition();
    while(p != NULL)
       { /* scan */
	WinErrorData * d = data.GetNext(p);
	if(d->value == v)
	   return d->name;
       } /* scan */
    return CString(_T(""));
   }

WinErrorTable WinError;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNTSTATUSExplorerDlg dialog

CNTSTATUSExplorerDlg::CNTSTATUSExplorerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNTSTATUSExplorerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNTSTATUSExplorerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	hTest = INVALID_HANDLE_VALUE;
}

void CNTSTATUSExplorerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNTSTATUSExplorerDlg)
	DDX_Control(pDX, IDC_PROGRESS, c_Progress);
	DDX_Control(pDX, IDC_BYRESULT, c_ByResult);
	DDX_Control(pDX, IDC_ERRORNAME, c_ByErrorName);
	DDX_Control(pDX, IDC_UNSORTED, c_Unsorted);
	DDX_Control(pDX, IDC_CLEAR, c_Clear);
	DDX_Control(pDX, IDC_BYVALUE, c_ByValue);
	DDX_Control(pDX, IDC_BYNAME, c_ByName);
	DDX_Control(pDX, IDC_NTSTATUS, c_NTSTATUS);
	DDX_Control(pDX, IDC_SELECTALL, c_SelectAll);
	DDX_Control(pDX, IDC_SAVE, c_Save);
	DDX_Control(pDX, IDC_GO, c_Go);
	DDX_Control(pDX, IDC_FIND, c_Find);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNTSTATUSExplorerDlg, CDialog)
	//{{AFX_MSG_MAP(CNTSTATUSExplorerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_BYNAME, OnByname)
	ON_BN_CLICKED(IDC_BYVALUE, OnByvalue)
	ON_BN_CLICKED(IDC_BYRESULT, OnByresult)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_SELECTALL, OnSelectall)
	ON_BN_CLICKED(IDC_FIND, OnFind)
	ON_BN_CLICKED(IDC_GO, OnGo)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_UNSORTED, OnUnsorted)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_WINERROR, OnWinerror)
	ON_BN_CLICKED(IDC_ERRORNAME, OnByErrorname)
	ON_BN_CLICKED(IDC_OUTPUT, OnOutput)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNTSTATUSExplorerDlg message handlers

BOOL CNTSTATUSExplorerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CheckRadioButton(IDC_BYNAME, IDC_UNSORTED, IDC_UNSORTED);
	c_Save.EnableWindow(FALSE);
	c_Clear.EnableWindow(FALSE);
	
	// Locate the test device

	hTest = CreateFile(
                     "\\\\.\\STATUSR",
                     GENERIC_READ | GENERIC_WRITE,
                     0,
                     NULL,
                     OPEN_EXISTING,
                     FILE_ATTRIBUTE_NORMAL,
                     NULL
                     );

        if(hTest == INVALID_HANDLE_VALUE)
	   { /* failed */
	    AfxMessageBox(IDS_DRIVER_NOT_LOADED);
	    // c_Go.EnableWindow(FALSE);
	   } /* failed */

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNTSTATUSExplorerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
 	switch(nID & 0xFFF0)
	   { /* nID */
	    case IDM_ABOUTBOX:
		{
		    CAboutDlg dlgAbout;
		    dlgAbout.DoModal();
		}
		    return;
	    case SC_CLOSE:
		    OnOK();
		    return;
	   } /* nID */
	CDialog::OnSysCommand(nID, lParam);
}

void CNTSTATUSExplorerDlg::OnDestroy()
{
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNTSTATUSExplorerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNTSTATUSExplorerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/****************************************************************************
*                       CNTSTATUSExplorerDlg::parseHeader
* Inputs:
*       CStdIoFile & file: INput file
* Result: void
*       
* Effect: 
*       Reads the file as best it can
****************************************************************************/

void CNTSTATUSExplorerDlg::parseHeader(CStdioFile & file)
    {
     CString s;
     CString parenNTSTATUS(_T("((NTSTATUS)"));
     CString hashDefine(_T("#define"));

     while(file.ReadString(s))
        { /* loop */
	 if(s.GetLength() == 0)
	     continue;
	 if(s[0] != '#')
	    continue;
         if(_tcsncmp(s, hashDefine, hashDefine.GetLength()) != 0)
	    continue;
         // #define name value
         // #define name  ((NTSTATUS)value)   
	 s = s.Mid(7);  // throw away first seven characters
	 s.TrimLeft();
         int pos = s.FindOneOf(_T(" \t"));
	 if(pos < 0)
	    continue; // no whitespace after name
	 CString name(s, pos);
	 s = s.Mid(pos);
	 s.TrimLeft();

	 // Is it ((NTSTATUS)?
	 if(_tcsncmp(s, parenNTSTATUS, parenNTSTATUS.GetLength()) != 0)
	    continue;
         s = s.Mid(parenNTSTATUS.GetLength());
	 // 0x00000000
	 DWORD value;
	 if(_tcsncmp(s, _T("0x"), 2) == 0 || _tcsncmp(s, _T("0X"), 2) == 0)
	    { /* hex */
	     s = s.Mid(2);
	     value = _tcstoul(s, NULL, 16);
	    } /* hex */
	 else
	    { /* decimal */
	     value = _tcstoul(s, NULL, 10);
	    } /* decimal */
	 c_NTSTATUS.AddString(name, value);
	} /* loop */
     c_Save.EnableWindow(TRUE);
     c_Clear.EnableWindow(TRUE);
    }

/****************************************************************************
*                         CNTSTATUSExplorerDlg::OnAdd
* Result: void
*       
* Effect: 
*       Adds the definitions from a header file to the list of names
****************************************************************************/

void CNTSTATUSExplorerDlg::OnAdd() 
{
 RegistryString filename(IDS_FILENAME);
 filename.load(_T("NTSTATUS.h"));
 CFileDialog dlg(TRUE, _T(".h"), filename.value); 
 switch(dlg.DoModal())
    { /* CFileDialog */
     case 0: return; // bogus
     case IDCANCEL: return; // cancelled
     case IDOK: break;
    } /* CFileDialog */

 CString name = dlg.GetPathName();

 CStdioFile input(name, CFile::modeRead);

 parseHeader(input);
 input.Close();
 filename.value = name;
 filename.store();
}

void CNTSTATUSExplorerDlg::OnByname() 
{
 c_NTSTATUS.SetSort(CStatusList::ByName);
 c_Unsorted.EnableWindow(FALSE);
}

void CNTSTATUSExplorerDlg::OnByvalue() 
{
 c_NTSTATUS.SetSort(CStatusList::ByValue);
 c_Unsorted.EnableWindow(FALSE);
}

void CNTSTATUSExplorerDlg::OnByresult() 
{
 c_NTSTATUS.SetSort(CStatusList::ByResult);
 c_Unsorted.EnableWindow(FALSE);
}

void CNTSTATUSExplorerDlg::OnByErrorname() 
{
 c_NTSTATUS.SetSort(CStatusList::ByWinError);
 c_Unsorted.EnableWindow(FALSE);	
}

void CNTSTATUSExplorerDlg::OnUnsorted() 
{
 c_NTSTATUS.SetSort(CStatusList::Unsorted);
	
}

void CNTSTATUSExplorerDlg::OnSave() 
{
 UINT key;
 if(c_ByName.GetCheck())
    key = IDS_OUTPUT_BY_STATUS_NAME;
 else
 if(c_ByValue.GetCheck())
    key = IDS_OUTPUT_BY_STATUS_VALUE;
 else
 if(c_ByResult.GetCheck())
    key = IDS_OUTPUT_BY_ERROR_VALUE;
 else
 if(c_ByErrorName.GetCheck())
    key = IDS_OUTPUT_BY_ERROR_NAME;
 else
    key = IDS_OUTPUT;

 RegistryString outputName(key);
 outputName.load(_T("NTSTATUS.lst"));
 CFileDialog dlg(FALSE, _T("lst"), outputName.value);
 switch(dlg.DoModal())
    { /* doModal */
     case 0:
	     return;
     case IDCANCEL:
	     return;
    } /* doModal */

 CString name = dlg.GetPathName();

 CWaitCursor cursor;
 TRY {
       CStdioFile output(name, CFile::modeCreate | CFile::modeWrite);
	
       c_NTSTATUS.Save(output);

       output.Close();
       outputName.value = name;
       outputName.store();
     }
 CATCH(CFileException, e)
     {
      // NYI: error
     }
 END_CATCH

}

void CNTSTATUSExplorerDlg::OnSelectall() 
{
 c_NTSTATUS.SetRedraw(FALSE);

 int count = c_NTSTATUS.GetCount();
 for(int i = 0; i < count; i++)
    c_NTSTATUS.SetSel(i, TRUE);	

 c_NTSTATUS.SetRedraw(TRUE);
 c_NTSTATUS.InvalidateRect(NULL);
}

void CNTSTATUSExplorerDlg::OnFind() 
{
	// TODO: Add your control notification handler code here
	
}

void CNTSTATUSExplorerDlg::OnGo() 
{
 CWaitCursor cursor;

 int sels = c_NTSTATUS.GetSelCount();
 int * selections = new int[sels];

 if(sels > 10)
    { /* progress */
     c_Progress.SetRange(0, sels);
     c_Progress.SetStep(1);
     c_Progress.ShowWindow(SW_SHOW);
    } /* progress */

 for(int i = 0; i < sels; i++)
    { /* process it */
     c_NTSTATUS.GetSelItems(sels, selections);
     DWORD value = c_NTSTATUS.GetValue(selections[i]);
     DWORD OutBuffer; // not actually used
     DWORD ReturnedLength; // not used, but required
     BOOL IoctlResult;
     
     c_Progress.StepIt();

     if(value == 0xFFFFFFFF)
	continue;

     DWORD result = 0;
     if(hTest != INVALID_HANDLE_VALUE)
        { /* do test */
	 IoctlResult = DeviceIoControl(
                            hTest,             // Handle to device
                            (unsigned long)IOCTL_FAIL_WITH, // IO Control code for Read
                            &value,            // Buffer to driver.
                            sizeof(value),     // Length of buffer in bytes.
                            &OutBuffer,        // Buffer from driver.
                            sizeof(OutBuffer), // Length of buffer in bytes.
                            &ReturnedLength,   // Bytes placed in DataBuffer.
                            NULL               // NULL means wait till op. completes.
                            );

	 if(!IoctlResult)
	    result = GetLastError();
	} /* do test */
     else
	{ /* debug mode */
	 result = ERROR_SERVICE_NOT_FOUND; // No service installed
	 result = ERROR_BAD_LENGTH;
	} /* debug mode */

     c_NTSTATUS.SetResult(selections[i], result, WinError.Lookup(result));
    } /* process it */

 c_Progress.ShowWindow(SW_HIDE);
 delete [] selections;
}

void CNTSTATUSExplorerDlg::OnOK() 
{
    if(hTest != INVALID_HANDLE_VALUE)
	CloseHandle(hTest);

    CDialog::OnOK();
}

void CNTSTATUSExplorerDlg::OnCancel() 
{
 	return; // disable ESC key
}

/****************************************************************************
*                     CNTSTATUSExplorerDlg::parseWinError
* Inputs:
*       CStdioFile & file: Input file
* Result: void
*       
* Effect: 
*       Parses the WinError.h file and creates the WinError symbol table
****************************************************************************/

void CNTSTATUSExplorerDlg::parseWinError(CStdioFile & file)
    {
     CString s;
     CString ERROR_(_T("ERROR_"));
     CString hashDefine(_T("#define"));
     CString RPC_(_T("RPC_"));
     CString EPT_S_(_T("EPT_S_"));

     while(file.ReadString(s))
        { /* scan */
	 if(s.GetLength() == 0)
	    continue;
	 if(s[0] != _T('#'))
	    continue;
         if(_tcsncmp(s, hashDefine, hashDefine.GetLength()) != 0)
	    continue;
         s = s.Mid(hashDefine.GetLength());
	 s.TrimLeft();
	 if(_tcsncmp(s, ERROR_, ERROR_.GetLength()) != 0  &&
            _tcsncmp(s, RPC_, RPC_.GetLength()) != 0  &&
	    _tcsncmp(s, EPT_S_, EPT_S_.GetLength()) != 0)
	    continue;
	 int pos = s.FindOneOf(_T(" \t"));
	 if(pos < 0)
	    continue; 
         CString name(s, pos);
         s = s.Mid(pos);
	 s.TrimLeft();
	 DWORD value;
	 value = _tcstoul(s, NULL, 10);
	 WinError.Add(name, value);
	} /* scan */
    }

/****************************************************************************
*                     void CNTSTATUSExplorerDlg::OnClear
* Result: void
*       
* Effect: 
*       Clears the listbox contents
****************************************************************************/

void CNTSTATUSExplorerDlg::OnClear()
    {
     c_NTSTATUS.ResetContent();
     c_Unsorted.EnableWindow(TRUE);
     c_Save.EnableWindow(FALSE);
     CheckRadioButton(IDC_BYNAME, IDC_UNSORTED, IDC_UNSORTED);
    }



void CNTSTATUSExplorerDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
 	CRect r;
	if(c_NTSTATUS.m_hWnd == NULL)
	   return;

	c_NTSTATUS.GetWindowRect(&r);
	ScreenToClient(&r);
	
	CRect c;
	GetClientRect(&c);
	c_NTSTATUS.MoveWindow(r.left, r.top, c.Width(), c.Height() - r.top);
	
}

void CNTSTATUSExplorerDlg::OnWinerror() 
{
 RegistryString filename(IDS_WINERROR);
 filename.load(_T("WinError.h"));
 CFileDialog dlg(TRUE, _T(".h"), filename.value); 
 switch(dlg.DoModal())
    { /* CFileDialog */
     case 0: return; // bogus
     case IDCANCEL: return; // cancelled
     case IDOK: break;
    } /* CFileDialog */

 CString name = dlg.GetPathName();

 CStdioFile input(name, CFile::modeRead);

 parseWinError(input);
 input.Close();
 filename.value = name;
 filename.store();
}



void CNTSTATUSExplorerDlg::OnOutput() 
{
 CFileOptions dlg;
 dlg.DoModal();	
}
